using OneReview.Domain;
using System.Collections.ObjectModel;

namespace OneReview.Services;

public class ProductService
{

    private static readonly List<Product> _ProductsRepository = [];
    // private static readonly List<User> _UsersRepository = [];

    public ReadOnlyCollection<Product> Get() =>
        _ProductsRepository.AsReadOnly();

    // 1. fetch user
    // 1. fetch product
    // 1. check wether the user reached the 
    // 1. update the user
    // 1. save the product
    public void Create(Product product)
    {
        // Guid userId, 
        if (product is null)
            throw new ArgumentNullException(nameof(product));

        // User user = _UsersRepository.Find(x => x.Id == userId)
        //     ?? throw new InvalidOperationException();

        // user.AddProduct(product);
        _ProductsRepository.Add(product);
    }

    public Product? Get(Guid productId) =>
        _ProductsRepository.Find(x => x.Id == productId);

}